# @bigbinary/neeto-molecules

![npm](https://img.shields.io/npm/v/@bigbinary/neeto-molecules?color=greenyellow)
![npm](https://img.shields.io/npm/dw/@bigbinary/neeto-molecules?color=greenyellow)

A package of reusable molecular components for neeto products.

## Demo (storybook)

https://neeto-molecules.neeto.com/

## Exported Components

- [AuditLogs](./docs/components/AuditLogs.md)
- [BoardView](./docs/components/BoardView.md)
- [Breadcrumbs](./docs/components/Breadcrumbs.md)
- [BrowserSupport](./docs/components/BrowserSupport.md)
- [Builder](./docs/components/Builder.md)
- [CalendarView](./docs/components/CalendarView.md)
- [CardLayout](./docs/components/CardLayout.md)
- [Codeblock](./docs/components/Codeblock.md)
- [Columns](./docs/components/Columns.md)
- [ConfirmationModal](./docs/components/ConfirmationModal.md)
- [Container](./docs/components/Container.md)
- [CopyToClipboardButton](./docs/components/CopyToClipboardButton.md)
- [Currency](./docs/components/Currency.md)
- [DateFormat/TimeFormat](./docs/components/DateFormatTimeFormat.md)
- [DateRangeFilter](./docs/components/DateRangeFilter.md)
- [DeleteArchiveModal](./docs/components/DeleteArchiveModal.md)
- [DocumentEditor](./docs/components/DocumentEditor.md)
- [DownloadMobileAppCallout](./docs/components/DownloadMobileAppCallout.md)
- [DynamicVariables](./docs/components/DynamicVariables.md)
- [EmailForm](./docs/components/EmailForm.md)
- [EmailFormProvider](./docs/components/EmailFormProvider.md)
- [EmailPreview](./docs/components/EmailPreview.md)
- [EmojiPicker](./docs/components/EmojiPicker.md)
- [EmojiReactions](./docs/components/EmojiReactions.md)
- [Engagements](./docs/components/Engagements.md)
- [ErrorPage](./docs/components/ErrorPage.md)
- [FileUpload](./docs/components/FileUpload.md)
- [FinderModal](./docs/components/FinderModal.md)
- [FloatingActionMenu](./docs/components/FloatingActionMenu.md)
- [GoogleFontPicker](./docs/components/GoogleFontPicker.md)
- [Header](./docs/components/Header.md)
- [HelpPopover](./docs/components/HelpPopover.md)
- [IconPicker](./docs/components/IconPicker.md)
- [ImageWithFallback](./docs/components/ImageWithFallback.md)
- [InlineInput](./docs/components/InlineInput.md)
- [IntegrationCard](./docs/components/IntegrationCard.md)
- [IpRestriction](./docs/components/IpRestriction.md)
- [KeyboardShortcuts](./docs/components/KeyboardShortcuts.md)
- [LoginPage](./docs/components/LoginPage.md)
- [MadeWith](./docs/components/MadeWith.md)
- [MenuBar](./docs/components/MenuBar.md)
- [Metadata](./docs/components/Metadata.md)
- [MoreDropdown](./docs/components/MoreDropdown.md)
- [NavigationHeader](./docs/components/NavigationHeader.md)
- [NeetoWidget](./docs/components/NeetoWidget.md)
- [Onboarding](./docs/components/Onboarding.md)
- [PageLoader](./docs/components/PageLoader.md)
- [PhoneNumber](./docs/components/PhoneNumber.md)
- [PublishBlock](./docs/components/PublishBlock.md)
- [PublishYourItem](./docs/components/PublishYourItem.md)
- [Rename](./docs/components/Rename.md)
- [ResponsiveDevicePicker](./docs/components/ResponsiveDevicePicker.md)
- [Schedule](./docs/components/Schedule.md)
- [Scrollable](./docs/components/Scrollable.md)
- [Search](./docs/components/Search.md)
- [SendToFields](./docs/components/SendToFields.md)
- [SessionEnvironment](./docs/components/SessionEnvironment.md)
- [Settings](./docs/components/Settings.md)
- [ShareViaEmail](./docs/components/ShareViaEmail.md)
- [ShareViaLink](./docs/components/ShareViaLink.md)
- [Sidebar](./docs/components/Sidebar.md)
- [StatusDropdown](./docs/components/StatusDropdown.md)
- [StickyRibbonsContainer](./docs/components/StickyRibbonsContainer.md)
- [SubHeader](./docs/components/SubHeader.md)
- [SuffixedInput](./docs/components/SuffixedInput.md)
- [TableWrapper](./docs/components/TableWrapper.md)
- [Taxonomy](./docs/components/Taxonomy.md)
- [TimezoneMismatchModal](./docs/components/TimezoneMismatchModal.md)
- [ToggleFeatureCard](./docs/components/ToggleFeatureCard.md)

## Installation Instructions

Install from npm:

```bash
yarn add "@bigbinary/neeto-molecules@latest"
```

## Other references

- [Development instructions](./docs/general/development-instructions.md)
- [Building and releasing](./docs/general/building-and-releasing.md)
- [Releasing beta versions](./docs/general/releasing-beta-versions.md)
