import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import { memo, useState, Fragment, useEffect, useMemo } from 'react';
import classnames from 'classnames';
import { capitalize, isPresent, hyphenate, isNotEmpty, findBy } from '@bigbinary/neeto-cist';
import useFetchNeetoApps from '@bigbinary/neeto-commons-frontend/react-utils/useFetchNeetoApps';
import useLocalStorage from '@bigbinary/neeto-commons-frontend/react-utils/useLocalStorage';
import { buildUrl } from '@bigbinary/neeto-commons-frontend/utils';
import Button from '@bigbinary/neetoui/Button';
import Typography from '@bigbinary/neetoui/Typography';
import { not, is, findLast } from 'ramda';
import { useTranslation } from 'react-i18next';
import { Link, useLocation, useHistory } from 'react-router-dom';
import { f as filterByPermissions, a as CheckPointNavLinks, _ as _Items, b as SELECTED_NAV_LINK_ROUTE_STORAGE_KEY, g as getSidebarStateLocalStorageKey, D as DEFAULT_HOME_PATH, S as SelectedLink, C as Chevron, c as getActiveConfigurePageLink } from './Chevron-DfSoxXBs.js';
import Neeto from '@bigbinary/neeto-icons/typeface-logos/Neeto';
import * as AppIcons from '@bigbinary/neeto-icons/typeface-logos';
import { jsx, jsxs, Fragment as Fragment$1 } from 'react/jsx-runtime';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import Down from '@bigbinary/neeto-icons/Down';
import '@bigbinary/neeto-commons-frontend/react-utils';
import '@bigbinary/neeto-commons-frontend/utils/general';
import '@bigbinary/neeto-icons/Home';
import '@bigbinary/neeto-filters-frontend/Segments';
import '@bigbinary/neeto-commons-frontend/react-utils/useRegisterNavigationCheckpoint';
import './inject-css-DmrvuTKK.js';

var Header = function Header(_ref) {
  var _ProductTypefaceLogos;
  var customLogo = _ref.customLogo,
    clearSettingsNav = _ref.clearSettingsNav,
    homePath = _ref.homePath;
  var productName = globalProps.appName.substr(5);
  var logoName = "Neeto".concat(capitalize(productName.toLowerCase()));
  var ProductTypefaceLogo = (_ProductTypefaceLogos = AppIcons[logoName]) !== null && _ProductTypefaceLogos !== void 0 ? _ProductTypefaceLogos : Neeto;
  var LogoComponent = customLogo !== null && customLogo !== void 0 ? customLogo : ProductTypefaceLogo;
  return /*#__PURE__*/jsx("div", {
    className: "neeto-molecules-sidebar__header neeto-molecules-sidebar__no-shrinkable",
    "data-cy": "sidebar-info",
    children: /*#__PURE__*/jsx(Link, {
      className: "neeto-molecules-sidebar__logo neeto-ui-w-full",
      to: homePath,
      onClick: clearSettingsNav,
      children: /*#__PURE__*/jsx(LogoComponent, {
        className: classnames({
          "neeto-molecules-sidebar__logo": !customLogo
        })
      })
    })
  });
};
var Header$1 = /*#__PURE__*/memo(Header);

var _excluded = ["label", "to", "icon", "items", "isConfigureNavLink", "isCountsLoading", "count", "component"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var renderCount = function renderCount(count) {
  return count > 999 ? "999+" : count;
};
var Links = function Links(_ref) {
  var navLinks = _ref.navLinks,
    isCountsLoadingDeprecated = _ref.isCountsLoading,
    setSelectedNavLinkRoute = _ref.setSelectedNavLinkRoute;
  var location = useLocation();
  var _useState = useState(true),
    _useState2 = _slicedToArray(_useState, 2),
    isActiveLinkExpanded = _useState2[0],
    setIsActiveLinkExpanded = _useState2[1];
  var handleNavLinkClick = function handleNavLinkClick(_ref2) {
    var event = _ref2.event,
      isActive = _ref2.isActive,
      navLink = _ref2.navLink;
    var isExpandable = isPresent(navLink.items) || isPresent(navLink.component);
    if (!isExpandable) return;
    if (navLink.isConfigureNavLink && isNotEmpty(navLink.items)) {
      setSelectedNavLinkRoute(navLink.to);
    }
    if (isActive()) {
      setIsActiveLinkExpanded(not);
      navLink.resetPath !== true && event.preventDefault();
      return;
    }
    setIsActiveLinkExpanded(true);
  };
  return /*#__PURE__*/jsx("div", {
    className: "neeto-molecules-sidebar__links neeto-molecules-sidebar__no-shrinkable",
    children: navLinks.filter(filterByPermissions).map(function (navLink, index) {
      var label = navLink.label,
        to = navLink.to,
        icon = navLink.icon,
        items = navLink.items,
        isConfigureNavLink = navLink.isConfigureNavLink,
        _navLink$isCountsLoad = navLink.isCountsLoading,
        isCountsLoading = _navLink$isCountsLoad === void 0 ? false : _navLink$isCountsLoad,
        _navLink$count = navLink.count,
        count = _navLink$count === void 0 ? null : _navLink$count,
        Component = navLink.component,
        otherProps = _objectWithoutProperties(navLink, _excluded);
      var IconSVG = icon;
      var url = new URL(to, window.location.href);
      var isActive = function isActive() {
        return is(Function, otherProps.isActive) ? otherProps.isActive() : location.pathname.startsWith(url.pathname);
      };
      var isExpandable = items || Component;
      var isMenuExpanded = isActive() && isActiveLinkExpanded && !isCountsLoadingDeprecated;
      return /*#__PURE__*/jsxs(Fragment, {
        children: [/*#__PURE__*/jsxs(CheckPointNavLinks, _objectSpread(_objectSpread({
          activeClassName: "active",
          className: "neeto-ui-flex neeto-ui-items-center neeto-ui-no-underline neeto-ui-select-none neeto-molecules-sidebar__link",
          "data-testid": "navlink-".concat(hyphenate(label)),
          onClick: function onClick(event) {
            return handleNavLinkClick({
              event: event,
              isActive: isActive,
              navLink: navLink
            });
          }
        }, _objectSpread({
          isActive: isActive,
          to: to
        }, otherProps)), {}, {
          children: [icon && /*#__PURE__*/jsxs("span", {
            className: "neeto-molecules-sidebar__link-icon",
            "data-testid": label,
            children: [/*#__PURE__*/jsx(IconSVG, {}), isPresent(count) && !isCountsLoading && /*#__PURE__*/jsx("span", {
              className: "neeto-molecules-sidebar__link-unread-count",
              children: renderCount(count)
            })]
          }), /*#__PURE__*/jsx(Typography, {
            className: "neeto-molecules-sidebar__link-label neeto-ui-flex-grow flex items-center gap-1",
            component: "span",
            style: "body2",
            children: label
          }), isExpandable && !isConfigureNavLink && /*#__PURE__*/jsx("span", {
            className: classnames("neeto-molecules-sidebar__link-icon neeto-molecules-sidebar__link-icon--caret", {
              "neeto-molecules-sidebar__link-icon--rotate": isMenuExpanded
            }),
            children: /*#__PURE__*/jsx(Down, {
              size: 16
            })
          })]
        })), isExpandable && !isConfigureNavLink && isMenuExpanded && /*#__PURE__*/jsxs(Fragment$1, {
          children: [items && /*#__PURE__*/jsx(_Items, _objectSpread({}, _objectSpread({
            isCountsLoading: isCountsLoading,
            items: items
          }, otherProps))), Component && /*#__PURE__*/jsx(Component, {
            navLink: navLink
          })]
        })]
      }, navLink.key || index);
    })
  });
};

var Sidebar = function Sidebar(_ref) {
  var navLinks = _ref.navLinks,
    customLogo = _ref.customLogo,
    _ref$isCountsLoading = _ref.isCountsLoading,
    isCountsLoading = _ref$isCountsLoading === void 0 ? false : _ref$isCountsLoading,
    _ref$showWorkspaceNam = _ref.showWorkspaceName,
    showWorkspaceName = _ref$showWorkspaceNam === void 0 ? false : _ref$showWorkspaceNam;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isSidebarPaneOpen = _useState2[0],
    setIsSidebarPaneOpen = _useState2[1];
  var _useLocalStorage = useLocalStorage(SELECTED_NAV_LINK_ROUTE_STORAGE_KEY, null),
    _useLocalStorage2 = _slicedToArray(_useLocalStorage, 2),
    selectedNavLinkRoute = _useLocalStorage2[0],
    setSelectedNavLinkRoute = _useLocalStorage2[1];
  var _useLocalStorage3 = useLocalStorage(getSidebarStateLocalStorageKey(), false),
    _useLocalStorage4 = _slicedToArray(_useLocalStorage3, 2),
    isSidebarCollapsed = _useLocalStorage4[0],
    setIsSidebarCollapsed = _useLocalStorage4[1];
  var location = useLocation();
  var history = useHistory();
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var _useFetchNeetoApps = useFetchNeetoApps(),
    data = _useFetchNeetoApps.data;
  var isLargerScreen = function isLargerScreen() {
    return window.innerWidth > 768;
  };
  var isSidebarClosed = isLargerScreen() ? isSidebarCollapsed : not(isSidebarPaneOpen);
  useEffect(function () {
    if (!isPresent(navLinks)) return;
    var currentLink = findLast(function (_ref2) {
      var to = _ref2.to,
        isActive = _ref2.isActive;
      var url = new URL(to, window.location.href);
      return is(Function, isActive) ? isActive() : location.pathname.includes(url.pathname);
    })(navLinks);
    if (isPresent(currentLink)) {
      setSelectedNavLinkRoute(currentLink.isConfigureNavLink ? currentLink.to : null);
    }
  }, []);
  useEffect(function () {
    var handleResize = function handleResize() {
      if (isLargerScreen()) return;
      setIsSidebarPaneOpen(false);
      setIsSidebarCollapsed(true);
    };
    window.addEventListener("resize", handleResize);
    return function () {
      return window.removeEventListener("resize", handleResize);
    };
  }, []);
  var handleGoBack = function handleGoBack(event) {
    event.preventDefault();
    setSelectedNavLinkRoute(null);
    var configureNavLink = getActiveConfigurePageLink({
      navLinks: navLinks,
      location: location
    });
    if (configureNavLink !== null && configureNavLink !== void 0 && configureNavLink.to) {
      history.push(buildUrl(configureNavLink.to));
    }
  };
  var homePath = useMemo(function () {
    if (!(data !== null && data !== void 0 && data.neetoApps)) return DEFAULT_HOME_PATH;
    var productName = globalProps.appName.substr(5);
    var thisApp = findBy({
      name: productName
    }, data.neetoApps);
    return thisApp !== null && thisApp !== void 0 && thisApp.url ? new URL(thisApp.url).pathname : DEFAULT_HOME_PATH;
  }, [data]);
  var activeLink = useMemo(function () {
    return navLinks.find(function (link) {
      if (is(Function, link.isActive)) return link.isActive();
      var url = new URL(link.to, window.location.href);
      return location.pathname.startsWith(url.pathname);
    });
  }, [location.pathname, navLinks]);
  var isSelectedNavLinkVisible = selectedNavLinkRoute && (activeLink === null || activeLink === void 0 ? void 0 : activeLink.to) === selectedNavLinkRoute && isNotEmpty(navLinks);
  return /*#__PURE__*/jsxs("div", {
    "data-testid": "sidebar-container",
    className: classnames("neeto-molecules-sidebar__wrapper", {
      "neeto-molecules-sidebar__wrapper--collapsed": isLargerScreen() ? isSidebarCollapsed : not(isSidebarPaneOpen)
    }),
    children: [/*#__PURE__*/jsx("div", {
      className: "neeto-molecules-sidebar__backdrop",
      onClick: function onClick() {
        setIsSidebarPaneOpen(false);
        setSelectedNavLinkRoute(null);
      }
    }), /*#__PURE__*/jsxs("div", {
      "data-cy": "sidebar-wrapper",
      "data-testid": "sidebar",
      className: classnames("neeto-molecules-sidebar neeto-ui-flex neeto-ui-flex-col neeto-ui-flex-shrink-0 neeto-ui-overflow-y-auto neeto-ui-overflow-x-hidden", {
        "neeto-molecules-sidebar--focus-mode": isPresent(selectedNavLinkRoute)
      }),
      children: [/*#__PURE__*/jsx(Header$1, {
        customLogo: customLogo,
        homePath: homePath,
        clearSettingsNav: function clearSettingsNav() {
          return setSelectedNavLinkRoute(null);
        }
      }), showWorkspaceName && /*#__PURE__*/jsxs("div", {
        className: "neeto-ui-bg-gray-100 neeto-molecules-sidebar__workspace-info",
        children: [/*#__PURE__*/jsx(Typography, {
          className: "neeto-ui-mb-1",
          style: "h5",
          weight: "semibold",
          children: t("neetoMolecules.sidebar.myWorkspace")
        }), /*#__PURE__*/jsx(Typography, {
          className: "neeto-ui-truncate",
          style: "body2",
          children: globalProps.organization.name
        })]
      }), isSelectedNavLinkVisible ? /*#__PURE__*/jsx(SelectedLink, {
        handleGoBack: handleGoBack,
        homePath: homePath,
        navLink: activeLink
      }) : /*#__PURE__*/jsx(Links, {
        isCountsLoading: isCountsLoading,
        navLinks: navLinks,
        setSelectedNavLinkRoute: setSelectedNavLinkRoute
      })]
    }), /*#__PURE__*/jsx(Button, {
      className: "neeto-molecules-sidebar__toggler",
      "data-cy": "neeto-molecules-sidebar-toggler",
      "data-testid": "sidebar-toggleButton",
      icon: function icon() {
        return /*#__PURE__*/jsx(Chevron, {});
      },
      style: isLargerScreen() ? "text" : "secondary",
      tooltipProps: {
        content: isSidebarClosed ? t("neetoMolecules.sidebar.showMenu") : t("neetoMolecules.sidebar.hideMenu"),
        position: "bottom",
        touch: ["hold", 500]
      },
      onClick: function onClick() {
        setIsSidebarCollapsed(!isSidebarCollapsed);
        setIsSidebarPaneOpen(not);
      }
    })]
  });
};

export { Sidebar as default };
//# sourceMappingURL=Sidebar.js.map
