'use strict';

var initializers = require('@bigbinary/neeto-commons-frontend/initializers');
var Callout = require('@bigbinary/neetoui/Callout');
var platform = require('./platform-BUcCb8Jx.js');
var reactI18next = require('react-i18next');
var reactRouterDom = require('react-router-dom');
var jsxRuntime = require('react/jsx-runtime');
require('./_commonjsHelpers-BJu3ubxk.js');

var MOBILE_PLATFORMS = ["Android", "iOS", "Windows Phone"];

var DownloadMobileAppCallout = function DownloadMobileAppCallout(_ref) {
  var _platform$os, _globalProps$appName;
  var excludePathRegex = _ref.excludePathRegex;
  var _useLocation = reactRouterDom.useLocation(),
    pathname = _useLocation.pathname;
  var isMobilePlatform = MOBILE_PLATFORMS.includes((_platform$os = platform.platform.os) === null || _platform$os === void 0 ? void 0 : _platform$os.family);
  if (!isMobilePlatform) return null;
  var shouldExcludePath = excludePathRegex && excludePathRegex.test(pathname);
  if (shouldExcludePath) return null;
  var appName = (_globalProps$appName = initializers.globalProps.appName) === null || _globalProps$appName === void 0 ? void 0 : _globalProps$appName.toLowerCase();
  var mobileAppDownloadUrl = "https://www.neeto.com/".concat(appName, "/mobile");
  return /*#__PURE__*/jsxRuntime.jsx(Callout, {
    className: "m-4 block",
    style: "warning",
    children: /*#__PURE__*/jsxRuntime.jsx(reactI18next.Trans, {
      i18nKey: "neetoMolecules.downloadMobileAppCallout.message",
      components: {
        a: /*#__PURE__*/jsxRuntime.jsx("a", {
          className: "neeto-ui-btn--style-link",
          href: mobileAppDownloadUrl,
          rel: "noreferrer",
          target: "_blank"
        })
      }
    })
  });
};

module.exports = DownloadMobileAppCallout;
//# sourceMappingURL=DownloadMobileAppCallout.js.map
