'use strict';

var _asyncToGenerator = require('@babel/runtime/helpers/asyncToGenerator');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _regeneratorRuntime = require('@babel/runtime/regenerator');
var React = require('react');
var Button$1 = require('@bigbinary/neetoui/Button');
var Toastr = require('@bigbinary/neetoui/Toastr');
var Typography = require('@bigbinary/neetoui/Typography');
var reactI18next = require('react-i18next');
var i18next = require('i18next');
var yup = require('yup');
var formik = require('formik');
var utils = require('@bigbinary/neeto-commons-frontend/utils');
var Button = require('@bigbinary/neetoui/formik/Button');
var Input = require('@bigbinary/neetoui/formik/Input');
var ramda = require('ramda');
var jsxRuntime = require('react/jsx-runtime');

function _interopNamespaceDefault(e) {
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}

var yup__namespace = /*#__PURE__*/_interopNamespaceDefault(yup);

var INITIAL_FORM_VALUES = {
  email: "",
  password: ""
};
var DEFAULT_EMAIL = "oliver@example.com";
var DEFAULT_PASSWORD = "welcome";
var LOGIN_FORM_VALIDATION_SCHEMA = yup__namespace.object().shape({
  email: yup__namespace.string().email(i18next.t("neetoMolecules.login.invalidEmail")).required(i18next.t("neetoMolecules.login.emailRequired")),
  password: yup__namespace.string().required(i18next.t("neetoMolecules.login.passwordRequired"))
});

var SignInForm = function SignInForm(_ref) {
  var handleFormSubmit = _ref.handleFormSubmit;
  var _useTranslation = reactI18next.useTranslation(),
    t = _useTranslation.t;
  var _getQueryParams = utils.getQueryParams(),
    _getQueryParams$email = _getQueryParams.email,
    email = _getQueryParams$email === void 0 ? "" : _getQueryParams$email;
  var emailPrefilledInitialValues = function emailPrefilledInitialValues() {
    return ramda.assoc("email", email, INITIAL_FORM_VALUES);
  };
  if (Button === undefined) {
    return /*#__PURE__*/jsxRuntime.jsx(reactI18next.Trans, {
      components: {
        code: /*#__PURE__*/jsxRuntime.jsx("code", {})
      },
      i18nKey: "neetoMolecules.login.installNeetoUI"
    });
  }
  return /*#__PURE__*/jsxRuntime.jsx(formik.Formik, {
    initialValues: emailPrefilledInitialValues(),
    validationSchema: LOGIN_FORM_VALIDATION_SCHEMA,
    onSubmit: handleFormSubmit,
    children: /*#__PURE__*/jsxRuntime.jsxs(formik.Form, {
      className: "w-full space-y-6",
      children: [/*#__PURE__*/jsxRuntime.jsx(Input, {
        required: true,
        "data-cy": "login-email-text-field",
        "data-test-id": "login-email",
        label: t("neetoMolecules.login.email"),
        name: "email",
        size: "large"
      }), /*#__PURE__*/jsxRuntime.jsx(Input, {
        required: true,
        "data-cy": "login-password-text-field",
        "data-test-id": "login-password",
        label: t("neetoMolecules.login.password"),
        name: "password",
        size: "large",
        type: "password"
      }), /*#__PURE__*/jsxRuntime.jsx(Button, {
        fullWidth: true,
        "data-cy": "login-submit-button",
        "data-test-id": "login-submit-button",
        label: t("neetoMolecules.login.login"),
        size: "large",
        style: "secondary",
        type: "submit"
      })]
    })
  });
};

var SignIn = function SignIn(_ref) {
  var handleSubmit = _ref.handleSubmit;
  var _useState = React.useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    isSubmitting = _useState2[0],
    setIsSubmitting = _useState2[1];
  var _useTranslation = reactI18next.useTranslation(),
    t = _useTranslation.t;
  var redirectAfterSuccessfulLogin = function redirectAfterSuccessfulLogin(redirectTo) {
    window.location.pathname = redirectTo || "/";
  };
  var handleFormSubmit = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee(formValues) {
      var response;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return handleSubmit({
              user: formValues
            });
          case 3:
            response = _context.sent;
            Toastr.success(t("neetoMolecules.login.success"));
            redirectAfterSuccessfulLogin(response.redirectTo);
            _context.next = 10;
            break;
          case 8:
            _context.prev = 8;
            _context.t0 = _context["catch"](0);
          case 10:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[0, 8]]);
    }));
    return function handleFormSubmit(_x) {
      return _ref2.apply(this, arguments);
    };
  }();
  var loginAsOliver = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            setIsSubmitting(true);
            _context2.next = 3;
            return handleFormSubmit({
              email: DEFAULT_EMAIL,
              password: DEFAULT_PASSWORD
            });
          case 3:
            setIsSubmitting(false);
          case 4:
          case "end":
            return _context2.stop();
        }
      }, _callee2);
    }));
    return function loginAsOliver() {
      return _ref3.apply(this, arguments);
    };
  }();
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    className: "flex h-screen w-full justify-center",
    children: /*#__PURE__*/jsxRuntime.jsxs("div", {
      className: "neeto-ui-bg-white neeto-ui-rounded-lg neeto-ui-shadow-sm w-full max-w-lg space-y-6 self-center p-8 sm:min-w-max sm:p-10",
      children: [/*#__PURE__*/jsxRuntime.jsx(Typography, {
        style: "h3",
        weight: "medium",
        children: /*#__PURE__*/jsxRuntime.jsx(reactI18next.Trans, {
          components: {
            bold: /*#__PURE__*/jsxRuntime.jsx("b", {
              "data-test-id": "organization-name"
            })
          },
          i18nKey: "neetoMolecules.login.toOrganizationAccount",
          values: {
            organizationName: globalProps.organization.name
          }
        })
      }), /*#__PURE__*/jsxRuntime.jsx(Button$1, {
        fullWidth: true,
        disabled: isSubmitting,
        label: t("neetoMolecules.login.loginAsOliver"),
        loading: isSubmitting,
        size: "large",
        style: "primary",
        onClick: loginAsOliver
      }), /*#__PURE__*/jsxRuntime.jsx(Typography, {
        className: "text-center",
        style: "body1",
        weight: "semibold",
        children: t("neetoMolecules.common.or").toLocaleUpperCase()
      }), /*#__PURE__*/jsxRuntime.jsx(SignInForm, {
        handleFormSubmit: handleFormSubmit
      })]
    })
  });
};

module.exports = SignIn;
//# sourceMappingURL=LoginPage.js.map
