'use strict';

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var React = require('react');
var classnames = require('classnames');
var neetoCist = require('@bigbinary/neeto-cist');
var Stepper = require('@bigbinary/neetoui/Stepper');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var initializers = require('@bigbinary/neeto-commons-frontend/initializers');
var withT = require('@bigbinary/neeto-commons-frontend/react-utils/withT');
var Button = require('@bigbinary/neetoui/Button');
var Typography = require('@bigbinary/neetoui/Typography');
var jsxRuntime = require('react/jsx-runtime');
var injectCss = require('./inject-css-vQvjPR2x.js');
var i18next = require('i18next');
var useBreakpoints = require('@bigbinary/neeto-commons-frontend/react-utils/useBreakpoints');
var RightArrow = require('@bigbinary/neeto-icons/RightArrow');
var reactI18next = require('react-i18next');

function ownKeys$1(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$1(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$1(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CompletedScreen = withT(function (_ref) {
  var t = _ref.t,
    completeButtonProps = _ref.completeButtonProps;
  return /*#__PURE__*/jsxRuntime.jsxs("div", {
    className: "neeto-molecules-onboarding__wrapper",
    "data-testid": "onboarding-congratulations-wrapper",
    children: [/*#__PURE__*/jsxRuntime.jsxs("div", {
      className: "mx-auto mb-6 w-full max-w-2xl space-y-2 px-6 pt-16",
      children: [/*#__PURE__*/jsxRuntime.jsx(Typography, {
        className: "text-center",
        "data-cy": "onboarding-congratulations-emoji",
        style: "h1",
        children: "\uD83C\uDF89"
      }), /*#__PURE__*/jsxRuntime.jsxs(Typography, {
        className: "text-center",
        "data-cy": "onboarding-congratulations-title",
        "data-testid": "onboarding-congratulations-title",
        style: "h1",
        children: [/*#__PURE__*/jsxRuntime.jsx("span", {
          className: "neeto-ui-text-success-500",
          children: t("neetoMolecules.onboarding.congratulations")
        }), /*#__PURE__*/jsxRuntime.jsx("br", {}), t("neetoMolecules.onboarding.readyToUse", {
          appName: neetoCist.capitalize(initializers.globalProps.appName)
        })]
      })]
    }), /*#__PURE__*/jsxRuntime.jsx(Button, _objectSpread$1({
      "data-cy": "onboarding-congratulations-button",
      "data-testid": "onboarding-congratulations-button",
      label: t("neetoMolecules.onboarding.helpScreen.startUsingButton", {
        appName: initializers.globalProps.appName
      })
    }, completeButtonProps))]
  });
});

var GENERAL_ONBOARDING_STEPS = {
  WELCOME: "welcome",
  HELP: "help",
  FINISH: "finish"
};

var css = ".neeto-molecules-onboarding__wrapper{align-items:center;display:flex;flex-direction:column;flex-grow:1;height:100vh;overflow-y:auto;padding:0;width:100%}.neeto-molecules-onboarding__container{display:flex;flex-direction:column;height:100vh;overflow-y:auto;position:relative;width:100%}.neeto-molecules-onboarding__stepper-wrapper{background-color:rgb(var(--neeto-ui-white));border-bottom:1px solid rgb(var(--neeto-ui-gray-200));display:flex;flex-shrink:0;padding:.5rem 1rem;width:100%}@media (min-width:1024px){.neeto-molecules-onboarding__stepper-wrapper{justify-content:center}}.neeto-molecules-onboarding__content{flex-grow:1;min-height:0;overflow-y:auto;width:100%}.neeto-molecules-onboarding__content--forward{animation:slideInRight .4s ease backwards}.neeto-molecules-onboarding__content--backward{animation:slideInLeft .4s ease backwards}@keyframes slideInRight{0%{opacity:0;transform:translateX(100%)}to{opacity:1;transform:translateX(0)}}@keyframes slideInLeft{0%{opacity:0;transform:translateX(-100%)}to{opacity:1;transform:translateX(0)}}";
injectCss.n(css,{});

var HelpScreen = function HelpScreen(_ref) {
  var setCurrentStep = _ref.setCurrentStep,
    helpScreenClassName = _ref.helpScreenClassName;
  var _useTranslation = reactI18next.useTranslation(),
    t = _useTranslation.t;
  var _useBreakpoints = useBreakpoints(),
    isSize = _useBreakpoints.isSize;
  return /*#__PURE__*/jsxRuntime.jsxs("div", {
    className: classnames("mx-auto w-full max-w-3xl space-y-6 px-6 pb-6 pt-16", helpScreenClassName),
    children: [/*#__PURE__*/jsxRuntime.jsxs("div", {
      className: "space-y-3",
      children: [/*#__PURE__*/jsxRuntime.jsx(Typography, {
        component: "h1",
        "data-cy": "onboarding-help-title",
        "data-testid": "onboarding-help-title",
        style: "h1",
        children: t("neetoMolecules.onboarding.helpScreen.title")
      }), /*#__PURE__*/jsxRuntime.jsx(Typography, {
        "data-cy": "onboarding-help-description",
        "data-testid": "onboarding-help-description",
        lineHeight: "normal",
        style: "body1",
        children: /*#__PURE__*/jsxRuntime.jsx(reactI18next.Trans, {
          i18nKey: "neetoMolecules.onboarding.helpScreen.description"
        })
      }), /*#__PURE__*/jsxRuntime.jsx("div", {
        className: "w-full pt-3",
        children: isSize("mobile") ? /*#__PURE__*/jsxRuntime.jsx("img", {
          alt: "",
          src: "https://ik.imagekit.io/d9mvewbju/Commons/help-and-support-mobile_j6wW7CpE9.svg?updatedAt=1741079500974"
        }) : /*#__PURE__*/jsxRuntime.jsx("img", {
          alt: "",
          src: "https://ik.imagekit.io/d9mvewbju/Commons/help-and-support_LTkojTxfp.svg?updatedAt=1741078939601"
        })
      })]
    }), /*#__PURE__*/jsxRuntime.jsx(Button, {
      "data-cy": "onboarding-help-button",
      "data-testid": "onboarding-help-button",
      icon: RightArrow,
      iconPosition: "right",
      label: t("neetoMolecules.onboarding.helpScreen.continueButton"),
      onClick: function onClick() {
        return setCurrentStep(GENERAL_ONBOARDING_STEPS.FINISH);
      }
    })]
  });
};

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var createSteps = function createSteps(onboardingSteps, setCurrentStep, currentStep, helpScreenClassName) {
  var helpStep = {
    key: GENERAL_ONBOARDING_STEPS.HELP,
    label: i18next.t("neetoMolecules.onboarding.helpLabel"),
    element: /*#__PURE__*/jsxRuntime.jsx(HelpScreen, {
      currentStep: currentStep,
      helpScreenClassName: helpScreenClassName,
      setCurrentStep: setCurrentStep
    })
  };
  return onboardingSteps.concat(helpStep).map(function (step, idx) {
    return _objectSpread(_objectSpread({}, step), {}, {
      id: idx + 1
    });
  });
};

var WelcomeScreen = withT(function (_ref) {
  var t = _ref.t,
    setCurrentStep = _ref.setCurrentStep,
    nextStep = _ref.nextStep;
  return /*#__PURE__*/jsxRuntime.jsxs("div", {
    className: "neeto-molecules-onboarding__wrapper",
    "data-testid": "onboarding-welcome-wrapper",
    children: [/*#__PURE__*/jsxRuntime.jsxs("div", {
      className: "mx-auto mb-6 w-full max-w-2xl space-y-2 px-6 pt-16",
      children: [/*#__PURE__*/jsxRuntime.jsx(Typography, {
        className: "text-center",
        "data-cy": "onboarding-welcome-title",
        "data-testid": "onboarding-welcome-title",
        style: "h1",
        children: t("neetoMolecules.onboarding.helpScreen.welcomeToTitle", {
          appName: neetoCist.capitalize(initializers.globalProps.appName)
        })
      }), /*#__PURE__*/jsxRuntime.jsx(Typography, {
        className: "text-center",
        "data-cy": "onboarding-welcome-description",
        "data-testid": "onboarding-welcome-description",
        lineHeight: "normal",
        style: "body1",
        children: t("neetoMolecules.onboarding.letUsCustomize", {
          appName: neetoCist.capitalize(initializers.globalProps.appName)
        })
      })]
    }), /*#__PURE__*/jsxRuntime.jsx(Button, {
      "data-cy": "onboarding-welcome-button",
      "data-testid": "onboarding-welcome-button",
      icon: RightArrow,
      label: t("neetoMolecules.onboarding.getStarted"),
      onClick: function onClick() {
        return setCurrentStep(nextStep);
      }
    })]
  });
});

var Onboarding = function Onboarding(_ref) {
  var _ref$currentStep = _ref.currentStep,
    currentStep = _ref$currentStep === void 0 ? GENERAL_ONBOARDING_STEPS.WELCOME : _ref$currentStep,
    _ref$setCurrentStep = _ref.setCurrentStep,
    setCurrentStep = _ref$setCurrentStep === void 0 ? neetoCist.noop : _ref$setCurrentStep,
    _ref$onboardingSteps = _ref.onboardingSteps,
    onboardingSteps = _ref$onboardingSteps === void 0 ? [] : _ref$onboardingSteps,
    _ref$completeButtonPr = _ref.completeButtonProps,
    completeButtonProps = _ref$completeButtonPr === void 0 ? {} : _ref$completeButtonPr,
    _ref$helpScreenClassN = _ref.helpScreenClassName,
    helpScreenClassName = _ref$helpScreenClassN === void 0 ? "" : _ref$helpScreenClassN,
    _ref$isAnimated = _ref.isAnimated,
    isAnimated = _ref$isAnimated === void 0 ? true : _ref$isAnimated,
    _ref$disableStepClick = _ref.disableStepClick,
    disableStepClick = _ref$disableStepClick === void 0 ? false : _ref$disableStepClick;
  var steps = React.useMemo(function () {
    return createSteps(onboardingSteps, setCurrentStep, currentStep, helpScreenClassName);
  }, [onboardingSteps]);
  var prevStep = React.useRef(currentStep);
  var _useState = React.useState(""),
    _useState2 = _slicedToArray(_useState, 2),
    direction = _useState2[0],
    setDirection = _useState2[1];
  var getOnboardingStepIndex = function getOnboardingStepIndex(stepKey) {
    return steps.findIndex(function (step) {
      return step.key === stepKey;
    });
  };
  React.useEffect(function () {
    if (currentStep === prevStep.current) return;
    setDirection(getOnboardingStepIndex(currentStep) > getOnboardingStepIndex(prevStep.current) ? "forward" : "backward");
    prevStep.current = currentStep;
  }, [currentStep]);
  if (currentStep === GENERAL_ONBOARDING_STEPS.WELCOME) {
    return /*#__PURE__*/jsxRuntime.jsx(WelcomeScreen, {
      currentStep: currentStep,
      setCurrentStep: setCurrentStep,
      nextStep: steps[0].key
    });
  }
  if (currentStep === GENERAL_ONBOARDING_STEPS.FINISH) {
    return /*#__PURE__*/jsxRuntime.jsx(CompletedScreen, {
      completeButtonProps: completeButtonProps
    });
  }
  var handleStepChange = function handleStepChange(index) {
    return setCurrentStep(steps[index].key);
  };
  var isStepperVisible = steps.length > 1;
  return /*#__PURE__*/jsxRuntime.jsxs("div", {
    className: classnames("neeto-molecules-onboarding__container", {
      "neeto-molecules-onboarding__wrapper": !isStepperVisible
    }),
    children: [isStepperVisible && /*#__PURE__*/jsxRuntime.jsx("div", {
      className: "neeto-molecules-onboarding__stepper-wrapper",
      children: /*#__PURE__*/jsxRuntime.jsx(Stepper, {
        steps: steps,
        activeIndex: neetoCist.findIndexBy({
          key: currentStep
        }, steps),
        setActiveIndex: disableStepClick ? neetoCist.noop : handleStepChange
      })
    }), steps.map(function (step, index) {
      return /*#__PURE__*/jsxRuntime.jsx("div", {
        className: classnames("neeto-molecules-onboarding__content", {
          "neeto-molecules-onboarding__content--forward overflow-x-hidden": isAnimated && direction === "forward",
          "neeto-molecules-onboarding__content--backward overflow-x-hidden": isAnimated && direction === "backward",
          hidden: currentStep !== step.key
        }),
        children: step === null || step === void 0 ? void 0 : step.element
      }, index);
    })]
  });
};

module.exports = Onboarding;
//# sourceMappingURL=Onboarding.js.map
