'use strict';

var _asyncToGenerator = require('@babel/runtime/helpers/asyncToGenerator');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var _regeneratorRuntime = require('@babel/runtime/regenerator');
var React = require('react');
var classnames = require('classnames');
var withT = require('@bigbinary/neeto-commons-frontend/react-utils/withT');
var ExternalLink = require('@bigbinary/neeto-icons/ExternalLink');
var Undo = require('@bigbinary/neeto-icons/Undo');
var Button = require('@bigbinary/neetoui/Button');
var Tooltip = require('@bigbinary/neetoui/Tooltip');
var Typography = require('@bigbinary/neetoui/Typography');
var ramda = require('ramda');
var reactI18next = require('react-i18next');
var reactUtils = require('@bigbinary/neeto-commons-frontend/react-utils');
var Alert = require('@bigbinary/neetoui/Alert');
var jsxRuntime = require('react/jsx-runtime');
var injectCss = require('./inject-css-vQvjPR2x.js');
var neetoCist = require('@bigbinary/neeto-cist');
var Pane = require('@bigbinary/neetoui/Pane');
var Switch = require('@bigbinary/neetoui/Switch');
var utils = require('@bigbinary/neeto-commons-frontend/utils');
var Profile = require('@bigbinary/neeto-team-members-frontend/Profile');
var DatePicker = require('@bigbinary/neetoui/DatePicker');
var initializers = require('@bigbinary/neeto-commons-frontend/initializers');

var _excluded$1 = ["t"];
function ownKeys$1(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$1(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$1(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var AlertBlock = reactUtils.withT(function (_ref) {
  var t = _ref.t,
    props = _objectWithoutProperties(_ref, _excluded$1);
  return /*#__PURE__*/jsxRuntime.jsx(Alert, _objectSpread$1({
    "data-cy": "reset-alert",
    "data-testid": "reset-alert",
    submitButtonLabel: t("neetoMolecules.common.actions.reset")
  }, props));
});

var css = ".neeto-molecules-publish-block{align-items:center;display:flex;gap:.75rem;justify-content:flex-end}.neeto-molecules-publish-block__action-btn{align-items:center;display:inline-flex;flex-direction:row;gap:.0625rem;justify-content:center}.neeto-molecules-publish-block__action-btn>div:first-child>.neeto-ui-btn{border-bottom-right-radius:0;border-top-right-radius:0}.neeto-molecules-publish-block__action-btn>.neeto-ui-btn:last-child{border-bottom-left-radius:0;border-top-left-radius:0}";
injectCss.n(css,{});

var _globalProps$user;
var TIME_FORMAT = "h A";
var DATE_FORMAT = ((_globalProps$user = initializers.globalProps.user) === null || _globalProps$user === void 0 ? void 0 : _globalProps$user.dateFormat) || "DD/MM/YYYY";

var disabledDate = function disabledDate(current) {
  return current && current < utils.dayjs().startOf("day");
};
var disabledTime = function disabledTime(selectedDate) {
  var current = utils.dayjs(selectedDate).startOf("day");
  var today = utils.dayjs().startOf("day");
  if (current.isBefore(today)) {
    return {
      disabledHours: function disabledHours() {
        return neetoCist.dynamicArray(24, function (i) {
          return i;
        });
      }
    };
  }
  if (current.isSame(today)) {
    var currentTime = utils.dayjs();
    return {
      disabledHours: function disabledHours() {
        return neetoCist.dynamicArray(currentTime.hour() + 1, function (i) {
          return i;
        });
      }
    };
  }
  return {};
};
var getDefaultDate = function getDefaultDate() {
  var currDate = utils.dayjs();
  currDate = currDate.hour(currDate.hour() + 1);
  if (currDate.minute() > 30) {
    currDate = currDate.hour(currDate.hour() + 1);
  }
  return currDate;
};

var Form = function Form(_ref) {
  var _globalProps$user$tim, _globalProps$user;
  var datetimeValue = _ref.datetimeValue,
    setDatetimeValue = _ref.setDatetimeValue,
    onClose = _ref.onClose;
  var _useTranslation = reactI18next.useTranslation(),
    t = _useTranslation.t;
  var _Profile$usePaneState = Profile.usePaneState(),
    _Profile$usePaneState2 = _slicedToArray(_Profile$usePaneState, 2);
    _Profile$usePaneState2[0];
    var setIsProfilePaneOpen = _Profile$usePaneState2[1];
  return /*#__PURE__*/jsxRuntime.jsxs("div", {
    className: "space-y-1",
    children: [/*#__PURE__*/jsxRuntime.jsx(DatePicker, {
      disabledDate: disabledDate,
      required: true,
      showTime: true,
      allowClear: false,
      "data-cy": "publish-later-datepicker-input-field",
      "data-testid": "publish-later-datepicker-input-field",
      dateFormat: DATE_FORMAT,
      label: t("neetoMolecules.publishBlock.dateTime"),
      timeFormat: TIME_FORMAT,
      value: datetimeValue,
      timePickerProps: {
        "data-cy": "publish-later-timepicker-input-field",
        "data-testid": "publish-later-timepicker-input-field",
        clearIcon: false,
        disabledTime: disabledTime
      },
      onChange: function onChange(date) {
        setDatetimeValue(date.startOf("hour"));
      }
    }), /*#__PURE__*/jsxRuntime.jsx(Typography, {
      style: "body3",
      children: /*#__PURE__*/jsxRuntime.jsx(reactI18next.Trans, {
        i18nKey: "neetoMolecules.publishBlock.timezoneDescription",
        values: {
          timezone: (_globalProps$user$tim = (_globalProps$user = globalProps.user) === null || _globalProps$user === void 0 ? void 0 : _globalProps$user.timeZone) !== null && _globalProps$user$tim !== void 0 ? _globalProps$user$tim : utils.dayjs.tz.guess()
        },
        components: {
          button: /*#__PURE__*/jsxRuntime.jsx(Button, {
            size: "small",
            style: "link",
            onClick: function onClick() {
              onClose();
              setIsProfilePaneOpen(true);
            }
          })
        }
      })
    })]
  });
};

var PublishLater = function PublishLater(_ref) {
  var setDatetimeValue = _ref.setDatetimeValue,
    datetimeValue = _ref.datetimeValue,
    onClose = _ref.onClose,
    isPublishLaterChecked = _ref.isPublishLaterChecked,
    setIsPublishLaterChecked = _ref.setIsPublishLaterChecked;
  var _useTranslation = reactI18next.useTranslation(),
    t = _useTranslation.t;
  var handleChangeSwitch = function handleChangeSwitch(event) {
    var checked = event.target.checked;
    setDatetimeValue(checked ? getDefaultDate() : "");
    setIsPublishLaterChecked(checked);
  };
  return /*#__PURE__*/jsxRuntime.jsxs(jsxRuntime.Fragment, {
    children: [/*#__PURE__*/jsxRuntime.jsxs("div", {
      className: "mb-6",
      children: [/*#__PURE__*/jsxRuntime.jsxs("div", {
        className: "flex w-full items-center space-x-2 py-1",
        children: [/*#__PURE__*/jsxRuntime.jsx(Switch, {
          checked: isPublishLaterChecked,
          "data-cy": "publish-later-switch",
          "data-testid": "publish-later-switch",
          onChange: handleChangeSwitch
        }), /*#__PURE__*/jsxRuntime.jsx(Typography, {
          style: "h4",
          weight: "medium",
          children: t("neetoMolecules.publishBlock.publishLater")
        })]
      }), /*#__PURE__*/jsxRuntime.jsx(Typography, {
        className: "mb-6",
        style: "body3",
        weight: "medium",
        children: t("neetoMolecules.publishBlock.helperText")
      })]
    }), isPublishLaterChecked && /*#__PURE__*/jsxRuntime.jsx(Form, {
      datetimeValue: datetimeValue,
      onClose: onClose,
      setDatetimeValue: setDatetimeValue
    })]
  });
};

var PublishSettings = reactUtils.withT(function (_ref) {
  var t = _ref.t,
    isSettingsPaneOpen = _ref.isSettingsPaneOpen,
    _onClose = _ref.onClose,
    _ref$isSubmitting = _ref.isSubmitting,
    isSubmitting = _ref$isSubmitting === void 0 ? false : _ref$isSubmitting,
    _ref$onPublish = _ref.onPublish,
    onPublish = _ref$onPublish === void 0 ? neetoCist.noop : _ref$onPublish,
    datetimeValue = _ref.datetimeValue,
    setDatetimeValue = _ref.setDatetimeValue,
    _ref$onCancel = _ref.onCancel,
    onCancel = _ref$onCancel === void 0 ? neetoCist.noop : _ref$onCancel,
    isPublishLaterChecked = _ref.isPublishLaterChecked,
    setIsPublishLaterChecked = _ref.setIsPublishLaterChecked;
  return /*#__PURE__*/jsxRuntime.jsxs(Pane, {
    isOpen: isSettingsPaneOpen,
    onClose: function onClose() {
      return onCancel({
        onClose: _onClose
      });
    },
    children: [/*#__PURE__*/jsxRuntime.jsx(Pane.Header, {
      children: /*#__PURE__*/jsxRuntime.jsx(Typography, {
        "data-cy": "publish-pane-heading",
        "data-testid": "publish-pane-heading",
        lineHeight: "normal",
        style: "h2",
        weight: "semibold",
        children: t("neetoMolecules.publishBlock.publishSettings")
      })
    }), /*#__PURE__*/jsxRuntime.jsx(Pane.Body, {
      children: /*#__PURE__*/jsxRuntime.jsx("div", {
        className: "w-full space-y-1",
        children: /*#__PURE__*/jsxRuntime.jsx(PublishLater, {
          datetimeValue: datetimeValue,
          isPublishLaterChecked: isPublishLaterChecked,
          onClose: _onClose,
          setDatetimeValue: setDatetimeValue,
          setIsPublishLaterChecked: setIsPublishLaterChecked
        })
      })
    }), /*#__PURE__*/jsxRuntime.jsxs(Pane.Footer, {
      className: "space-x-2",
      children: [/*#__PURE__*/jsxRuntime.jsx(Button, {
        "data-cy": "publish-submit-button",
        "data-testid": "publish-submit-button",
        disabled: isSubmitting,
        loading: isSubmitting,
        label: isPublishLaterChecked ? t("neetoMolecules.publishBlock.publishLater") : t("neetoMolecules.publishBlock.publishNow"),
        onClick: function onClick() {
          return onPublish({
            isPublishLaterChecked: isPublishLaterChecked,
            datetimeValue: datetimeValue,
            onClose: _onClose
          });
        }
      }), /*#__PURE__*/jsxRuntime.jsx(Button, {
        "data-cy": "publish-cancel-button",
        "data-testid": "publish-cancel-button",
        label: t("neetoMolecules.common.actions.cancel"),
        style: "text",
        onClick: function onClick() {
          return onCancel({
            onClose: _onClose
          });
        }
      })]
    })]
  });
});

var _excluded = ["t"],
  _excluded2 = ["t"],
  _excluded3 = ["tooltipProps", "showTooltipWhenDisabled", "disabled", "publishPaneProps", "onClick"],
  _excluded4 = ["t"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var unUsedI18nProps = ["tReady", "i18n"];
var ViewDraftButton = withT(function (_ref) {
  var t = _ref.t,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/jsxRuntime.jsx(Button, _objectSpread({
    "data-cy": "view-draft-button",
    "data-testid": "view-draft-button",
    icon: ExternalLink,
    style: "secondary",
    target: "_blank",
    tooltipProps: {
      content: t("neetoMolecules.publishBlock.viewDraftVersion"),
      position: "top",
      touch: ["hold", 500]
    }
  }, ramda.omit(unUsedI18nProps, props)));
});
var ResetDraftButton = withT(function (_ref2) {
  var t = _ref2.t,
    props = _objectWithoutProperties(_ref2, _excluded2);
  return /*#__PURE__*/jsxRuntime.jsx(Button, _objectSpread({
    "data-cy": "draft-button",
    "data-testid": "draft-button",
    icon: Undo,
    style: "secondary",
    tooltipProps: {
      content: t("neetoMolecules.publishBlock.deleteDraftVersion"),
      position: "top",
      touch: ["hold", 500]
    }
  }, ramda.omit(unUsedI18nProps, props)));
});
var PublishButton = function PublishButton(_ref3) {
  var tooltipProps = _ref3.tooltipProps,
    _ref3$showTooltipWhen = _ref3.showTooltipWhenDisabled,
    showTooltipWhenDisabled = _ref3$showTooltipWhen === void 0 ? false : _ref3$showTooltipWhen,
    _ref3$disabled = _ref3.disabled,
    disabled = _ref3$disabled === void 0 ? false : _ref3$disabled,
    _ref3$publishPaneProp = _ref3.publishPaneProps,
    publishPaneProps = _ref3$publishPaneProp === void 0 ? {} : _ref3$publishPaneProp,
    onClick = _ref3.onClick,
    props = _objectWithoutProperties(_ref3, _excluded3);
  var _useTranslation = reactI18next.useTranslation(),
    t = _useTranslation.t;
  var onPublish = publishPaneProps.onPublish,
    onCancel = publishPaneProps.onCancel,
    isSubmitting = publishPaneProps.isSubmitting,
    datetime = publishPaneProps.datetime;
  var isPublishLaterDisabled = ramda.isEmpty(publishPaneProps);
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isSettingsPaneOpen = _useState2[0],
    setIsSettingsPaneOpen = _useState2[1];
  var _useState3 = React.useState(datetime),
    _useState4 = _slicedToArray(_useState3, 2),
    datetimeValue = _useState4[0],
    setDatetimeValue = _useState4[1];
  var _useState5 = React.useState(!!datetime),
    _useState6 = _slicedToArray(_useState5, 2),
    isPublishLaterChecked = _useState6[0],
    setIsPublishLaterChecked = _useState6[1];
  var handleClick = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (!isPublishLaterDisabled) {
              _context.next = 5;
              break;
            }
            _context.next = 3;
            return onClick === null || onClick === void 0 ? void 0 : onClick();
          case 3:
            _context.next = 7;
            break;
          case 5:
            _context.next = 7;
            return onClick === null || onClick === void 0 ? void 0 : onClick({
              setIsSettingsPaneOpen: setIsSettingsPaneOpen
            });
          case 7:
            if (!isPublishLaterDisabled) {
              _context.next = 9;
              break;
            }
            return _context.abrupt("return");
          case 9:
            setDatetimeValue(datetime || "");
            setIsPublishLaterChecked(!!datetime);
          case 11:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function handleClick() {
      return _ref4.apply(this, arguments);
    };
  }();
  React.useEffect(function () {
    setDatetimeValue(datetime);
  }, [datetime]);
  return /*#__PURE__*/jsxRuntime.jsxs(jsxRuntime.Fragment, {
    children: [/*#__PURE__*/jsxRuntime.jsx(Tooltip, _objectSpread(_objectSpread({}, tooltipProps), {}, {
      disabled: !tooltipProps || !showTooltipWhenDisabled && disabled,
      children: /*#__PURE__*/jsxRuntime.jsx("div", {
        children: /*#__PURE__*/jsxRuntime.jsx(Button, _objectSpread({
          "data-cy": "publish-button",
          "data-testid": "publish-button",
          label: t("neetoMolecules.common.actions.publish"),
          onClick: handleClick
        }, _objectSpread({
          disabled: disabled
        }, props)))
      })
    })), /*#__PURE__*/jsxRuntime.jsx(PublishSettings, {
      datetimeValue: datetimeValue,
      isPublishLaterChecked: isPublishLaterChecked,
      isSettingsPaneOpen: isSettingsPaneOpen,
      isSubmitting: isSubmitting,
      onCancel: onCancel,
      onPublish: onPublish,
      setDatetimeValue: setDatetimeValue,
      setIsPublishLaterChecked: setIsPublishLaterChecked,
      onClose: function onClose() {
        return setIsSettingsPaneOpen(false);
      }
    })]
  });
};
var PublishPreviewButton = withT(function (_ref5) {
  var t = _ref5.t,
    props = _objectWithoutProperties(_ref5, _excluded4);
  return /*#__PURE__*/jsxRuntime.jsx(Button, _objectSpread({
    "data-cy": "publish-preview-button",
    "data-testid": "publish-preview-button",
    icon: ExternalLink,
    target: "_blank",
    className: classnames({
      "pointer-events-none": props.disabled
    }, props.className),
    tooltipProps: {
      content: t("neetoMolecules.publishBlock.viewPublishedVersion"),
      position: "top",
      touch: ["hold", 500]
    }
  }, ramda.omit(unUsedI18nProps, props)));
});
var PublishBlock = function PublishBlock(_ref6) {
  var renderDraftButtons = _ref6.renderDraftButtons,
    renderPublishButtons = _ref6.renderPublishButtons;
  var _useTranslation2 = reactI18next.useTranslation(),
    t = _useTranslation2.t;
  var draftBlockButtons = renderDraftButtons({
    ViewDraftButton: ViewDraftButton,
    ResetDraftButton: ResetDraftButton
  });
  return /*#__PURE__*/jsxRuntime.jsxs("div", {
    className: "neeto-molecules-publish-block",
    "data-cy": "neeto-molecules-publish-block",
    "data-testid": "neeto-molecules-publish-block",
    children: [draftBlockButtons && /*#__PURE__*/jsxRuntime.jsxs(jsxRuntime.Fragment, {
      children: [/*#__PURE__*/jsxRuntime.jsxs("div", {
        className: "flex items-center gap-2",
        children: [/*#__PURE__*/jsxRuntime.jsx(Typography, {
          className: "neeto-ui-text-gray-700",
          "data-cy": "publish-block-draft-label",
          lineHeight: "normal",
          style: "body2",
          children: t("neetoMolecules.common.actions.draft")
        }), /*#__PURE__*/jsxRuntime.jsx("div", {
          className: "flex items-center gap-1",
          children: draftBlockButtons
        })]
      }), /*#__PURE__*/jsxRuntime.jsx("div", {
        className: "neeto-ui-bg-gray-300 h-full w-px"
      })]
    }), /*#__PURE__*/jsxRuntime.jsx("div", {
      className: "neeto-molecules-publish-block__action-btn",
      children: renderPublishButtons({
        PublishButton: PublishButton,
        PublishPreviewButton: PublishPreviewButton
      })
    })]
  });
};
PublishBlock.Alert = AlertBlock;

module.exports = PublishBlock;
//# sourceMappingURL=PublishBlock.js.map
