import React from 'react';

/**
 *
 * Component to show breadcrumbs
 *
 * @example 
 *
 * import Breadcrumbs from "@bigbinary/neeto-molecules/Breadcrumbs";
 * 
 * const SETTINGS_BREADCRUMBS = [
 *   {
 *     text: "Settings",
 *     link: "/admin/settings",
 *   },
 * ];
 * 
 * const Page = () => <Breadcrumbs Breadcrumbs={SETTINGS_BREADCRUMBS} />;
 * @endexample
*/
declare const Breadcrumbs: React.FC<{
  breadcrumbs?: {
    text: string;
    link: string;
  }[];
  hasTrailingSeparator?: boolean;
  className?: string;
}>;

export { Breadcrumbs as default };
