import React from 'react';

/**
 *
 * The BrowserPreview component is used to render the content wrapped in the
 *
 * browser frame for preview purposes.
 *
 * @example 
 *
 * import BrowserPreview from "@bigbinary/neeto-molecules/BrowserPreview";
 * 
 * const Component = () => (
 *   <BrowserPreview>
 *     <div className="flex h-full items-center justify-center">
 *       <Typography className="text-center" style="body2">
 *         This is the body of the browser preview
 *       </Typography>
 *     </div>
 *   </BrowserPreview>
 * );
 * @endexample
*/
declare const BrowserPreview: React.FC<{
  wrapperClassName?: string;
  className?: string;
  children?: React.ReactNode;
}>;

export { BrowserPreview as default };
