import React from 'react';

/**
 *
 * The CardLayout component is used to render the content wrapped in the card
 *
 * layout.
 *
 * @example 
 *
 * import CardLayout from "@bigbinary/neeto-molecules/CardLayout";
 * 
 * const Component = () => (
 *   <CardLayout
 *     title="Set start day of the week"
 *     description="Choose your preferred start day of the week. This setting will be applied to all calendars."
 *     actionBlock={<Button label="Primary action" />}
 *   >
 *     {children}
 *   </CardLayout>
 * );
 * @endexample
*/
declare const CardLayout: React.FC<{
  title?: string;
  description?: React.ReactNode;
  className?: string;
  containerClassName?: string;
  children?: React.ReactNode;
  actionBlock?: React.ReactNode;
  icon?: React.ReactNode;
}>;

export { CardLayout as default };
