import React from 'react';

interface CopyToClipboardButtonProps {
  className?: string;
  icon?: string | any;
  label?: string;
  successLabel?: string;
  tooltipContent?: string;
  successTooltipContent?: string;
  value: string;
  style?: "primary" | "secondary" | "text";
}
/**
 *
 * A button that copies the given value to the clipboard.
 *
 * @example 
 *
 * import CopyToClipboardButton from "@bigbinary/neeto-molecules/CopyToClipboardButton";
 * 
 * const CopyToClipboardDemo = ({ value }) => (
 *   <CopyToClipboardButton label="Copy text" value={value} />
 * );
 * @endexample
*/
declare const CopyToClipboardButton: React.FC<CopyToClipboardButtonProps>;

export { type CopyToClipboardButtonProps, CopyToClipboardButton as default };
