import React from 'react';

/**
 *
 * Used to indicate screen incompatibility on smaller devices.
 *
 * @example 
 *
 * import DeviceIncompatibilityMessage from "@bigbinary/neeto-molecules/DeviceIncompatibilityMessage";
 * 
 * const App = () => <DeviceIncompatibilityMessage />;
 * @endexample
*/
declare const DeviceIncompatibilityMessage: React.FC<{
  description?: React.ReactNode;
  className?: string;
}>;

export { DeviceIncompatibilityMessage as default };
