import React from 'react';
import { ButtonProps } from '@bigbinary/neetoui';

/**
 *
 * A fallback page for handling 404, 403 and 500 errors.
 *
 * The component also has a "contact us" link that opens the chat widget for
 *
 * further communication.
 *
*/
declare const ErrorPage: React.FC<{
  homeUrl?: string;
  status?: number;
  backToHomeButtonProps?: Partial<ButtonProps>;
  children?: React.ReactNode | React.ReactNode[];
  showNeetoChatWidget?: boolean;
  description?: string;
}>;

export { ErrorPage as default };
