import React from 'react';
import { SIZES } from 'components/Header/constants';
import { PopoverProps } from 'neetoui';
import MoreDropdown from './MoreDropdown.js';
import '@bigbinary/neetoui';

interface HeaderProps {
  title?: React.ReactNode;
  titleHelpPopoverProps?: PopoverProps;
  className?: string;
  actionBlock?: React.ReactNode;
  searchProps?: object;
  breadcrumbs?: {
    text: string;
    link?: string;
  }[];
  size?: keyof typeof SIZES;
  renderDropdown?: (Dropdown: MoreDropdown) => JSX.Element;
}
/**
 *
 * The Header component can be used to display the page title and an action block
 *
 * to perform the main operations on the page.
 *
 * @example 
 *
 * import Header from "@bigbinary/neeto-molecules/Header";
 * 
 * const App = () => (
 *   <Header title="Heading" actionBlock={<Button label="Primary action" />} />
 * );
 * @endexample
*/
declare const Header: React.FC<HeaderProps>;

export { type HeaderProps, Header as default };
