import React from 'react';

/**
 *
 * A component to display a fallback component in case no image is available.
 *
 * @example 
 *
 * import ImageWithFallback from "@bigbinary/neeto-molecules/ImageWithFallback";
 * 
 * const App = () => (
 *   <ImageWithFallback
 *     className="h-40 w-40"
 *     src="https://randomuser.me/api/portraits/women/90.jpg"
 *   />
 * );
 * @endexample
*/
declare const ImageWithFallback: React.FC<{
  src: string;
  fallback?: React.ReactNode;
}>;

export { ImageWithFallback as default };
