import React from 'react';

/**
 *
 * A common component to restrict IPs in neeto applications.
 *
 * ![Ip](https://user-images.githubusercontent.com/49012815/279694376-0db130f0-1a54-4bd4-8456-1c5e6865856f.png|height=200|width=300)
 *
 * @example 
 *
 * import IpRestriction from "@bigbinary/neeto-molecules/IpRestriction";
 * 
 * const IpRestrictionSetting = () => (
 *   <Container isHeaderFixed className="w-full">
 *     <Header title="IP Restrictions" />
 *     <Scrollable className="w-full">
 *       <IpRestriction />
 *     </Scrollable>
 *   </Container>
 * );
 * @endexample
*/
declare const IpRestriction: React.FC<{}>;

export { IpRestriction as default };
