import React from 'react';

/**
 *
 * A common login page for all neeto-applications with dedicated button for oliver
 *
 * to login.
 *
 * undefined
 *
 * @example 
 *
 * import LoginPage from "@bigbinary/neeto-molecules/LoginPage";
 * 
 * // Main.jsx
 * export default function Main() {
 *   if (!isLoggedIn) {
 *     return <LoginPage handleSubmit={payload => sessionsApi.create(payload)} />;
 *   }
 * 
 *   // return main routes
 * }
 * @endexample
 * The payload will be of the following format:
 *
 * @example 
 *
 * {
 *   "user": {
 *     "email": "oliver@example.com",
 *     "password": "welcome"
 *   }
 * }
 * @endexample
*/
declare const LoginPage: React.FC<{
  handleSubmit: (data: {
    user: {
      email: string;
      password: string;
    };
  }) => any;
}>;

export { LoginPage as default };
