import React from 'react';

type EmbedCode = React.FC<{
  maxWidth?: string;
  primaryApp?: string;
  showSessionContext?: boolean;
  showUserIdentity?: boolean;
}>;
/**
 *
 * This component can be accessed only in SSO mode. To access the component, run
 *
 * neetoAuth in the background and restart the application in SSO mode.
 *
 * This object contains the widget names.
 *
 * This component can be used to render the neetoWidget embed code within any
 *
 * host application. It uses APIs from neeto_sso to query the apiKey from
 *
 * neeto-auth-web, enable/disable widgets, and to allow the user to send the
 *
 * embed code via email.
 *
 * Developers can use the props to customize the component for the host
 *
 * application.
 *
 * @example 
 *
 * <NeetoWidget.EmbedCode primaryApp={NeetoWidget.WIDGET_TYPES.chat} />
 * @endexample
*/
declare const NeetoWidget: {
  EmbedCode: EmbedCode;
  WIDGET_TYPES: {
    engage: "engage";
    chat: "chat";
    replay: "replay";
  };
};

export { NeetoWidget as default };
