import React from 'react';
import { InputProps } from 'neetoui';

/**
 *
 * A common search component with search value debounced
 *
 * @example 
 *
 * import Search from "@bigbinary/neeto-molecules/Search";
 * 
 * const Page = () => <Search debounceTime={500} onChange={e => noop} />;
 * @endexample
*/
declare const Search: React.FC<{
  debounceTime?: number;
  onSearch?: (value: string) => void;
  enableUrlSync?: boolean;
  searchParamName?: string;
} & InputProps>;

export { Search as default };
