import React from 'react';

/**
 *
 * A container that displays the sticky ribbons configured for the current Neeto
 *
 * application in NeetoTower, if any. The sticky ribbons will be automatically
 *
 * fetched from NeetoTower and displayed within the container. A refresh ribbon is
 *
 * displayed when showRefreshRibbon in useErrorDisplayStore is set to true.
 *
 * @example 
 *
 * import StickyRibbonsContainer from "@bigbinary/neeto-molecules/StickyRibbonsContainer";
 * 
 * const Main = () => (
 *   <>
 *     <ToastContainer />
 *     <StickyRibbonsContainer />
 *     <Switch>
 *       <Route />
 *     </Switch>
 *   </>
 * );
 * @endexample
*/
declare const StickyRibbonsContainer: React.FC<{}>;

export { StickyRibbonsContainer as default };
