import React from 'react';

/**
 *
 * A container that shows subscription notifications for the current workspace, if available.
 *
 * Notifications are automatically fetched from NeetoAuth and displayed within the container.
 *
 * @example 
 *
 * import SubscriptionNotificationsContainer from "@bigbinary/neeto-molecules/SubscriptionNotificationsContainer";
 * 
 * const Main = () => (
 *   <>
 *     <ToastContainer />
 *     <SubscriptionNotificationsContainer />
 *     <Switch>
 *       <Route />
 *     </Switch>
 *   </>
 * );
 * @endexample
*/
declare const SubscriptionNotificationsContainer: React.FC<{}>;

export { SubscriptionNotificationsContainer as default };
