import React from 'react';

/**
 *
 * TableWrapper is used to wrap the table component. It is used to avoid the
 *
 * dynamic height calculation and inconsistency in heights for the parent container
 *
 * of the table component. TableWrapper is used to wrap the table component. It is
 *
 * used to avoid the dynamic height calculation and inconsistency in heights for
 *
 * the parent container of the table component.
 *
 * TableWrapper should be used only with Tables used in the listing layout as shown
 *
 * below.
 *
 * @example 
 *
 * import TableWrapper from "@bigbinary/neeto-molecules/TableWrapper";
 * 
 * const App = () => (
 *   <Container>
 *     <Header />
 *     <SubHeader />
 *     <TableWrapper>
 *       <Table columnData={columnData} rowData={rowData} />
 *     </TableWrapper>
 *   </Container>
 * );
 * @endexample
*/
declare const TableWrapper: React.FC<{
  hasPagination?: boolean;
  className?: string;
  children: React.ReactNode;
}>;

export { TableWrapper as default };
