import React from 'react';
import { InputProps, ButtonProps, SwitchProps as SwitchProps$1 } from 'neetoui';

type TooltipProps = {
  enabledSwitchText?: string;
  disabledSwitchText?: string;
};
interface SwitchProps extends SwitchProps$1 {
  tooltipProps?: TooltipProps;
}
/**
 *
 * ToggleFeatureCard can be used to enable or disable a setting, and supports
 *
 * additional customizations like having an input field, and custom child
 *
 * components.
 *
 * ![image](https://github.com/bigbinary/neeto-molecules/assets/66865722/ed5c589f-7086-46b9-b8b2-2746afa7e750|height=200|width=300)
 *
*/
declare const ToggleFeatureCard: React.FC<{
  title: string;
  description?: string;
  switchName: string;
  titleDataCy?: string;
  switchDataCy?: string;
  descriptionDataCy?: string;
  isDisabled?: boolean;
  isCardStyleEnabled?: boolean;
  children?: React.ReactNode | null;
  inputProps?: InputProps;
  switchProps?: SwitchProps;
  editButtonProps?: ButtonProps;
  className?: string;
}>;

export { ToggleFeatureCard as default };
